﻿using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Exchange.Data.Transport;
using Microsoft.Exchange.Data.Transport.Email;
using Microsoft.Exchange.Data.Transport.Smtp;
using Microsoft.Exchange.Data.Transport.Routing;

namespace routeBalancer
{
    public class routeBalancerAgent : RoutingAgent
    {

        private RoutingOverride connector;


        public routeBalancerAgent(RoutingOverride conn)
        {
            this.connector = conn;
            this.OnResolvedMessage += new ResolvedMessageEventHandler(this.OnResolvedMessageHandler);
        }

        public void OnResolvedMessageHandler(ResolvedMessageEventSource source, QueuedMessageEventArgs e)
        {
            try
            {
                foreach (EnvelopeRecipient recp in e.MailItem.Recipients)
                {
                    source.SetRoutingOverride(recp, connector);
                }

            }
            catch (Exception except)
            {
                throw except;
            }
        }

    }
}
