$EXDIR="C:\Program Files\Microsoft\Exchange Server\V14\TransportRoles\agents\"

write-output "Preparing for installation"
net stop MSExchangeTransport

new-item -Type Directory -path $EXDIR\routeBalancer -ErrorAction SilentlyContinue


write-output "Copying files"
copy-item routeBalancer.dll $EXDIR\routeBalancer -force
copy-item RouteBalancerConfig.xml $EXDIR\routeBalancer -force


write-output "Registering agent"
install-transportagent -Name routeBalancer -AssemblyPath $EXDIR\routeBalancer\routeBalancer.dll -TransportAgentFactory routeBalancer.routeBalancerAgentFactory

write-output "Enabling agent"
enable-transportagent -Identity "routeBalancer"
get-transportagent -Identity "routeBalancer"

write-output "Starting Edge Transport"

net start MSExchangeTransport